"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.persistentCollectionReducer = exports.persistentDocumentReducer = exports.persistentReducer = exports.persistStore = exports.waitSync = void 0;

var _persistentArrayReducer = _interopRequireWildcard(require("./persistentArrayReducer"));

var _persistentObjectReducer = _interopRequireWildcard(require("./persistentObjectReducer"));

var _waitAvailability = _interopRequireDefault(require("./utils/waitAvailability"));

var _log = _interopRequireDefault(require("./utils/log"));

var _store;

var storeGetter = function storeGetter() {
  return _store;
};

var waitSync = function waitSync(reducerName) {
  return (0, _waitAvailability["default"])(function () {
    (0, _log["default"])('waitSync', !!_store, !!(0, _persistentObjectReducer.isObjectUpToDate)(reducerName), !!(0, _persistentArrayReducer.isArrayUpToDate)(reducerName));
    return _store && (0, _persistentArrayReducer.isArrayUpToDate)(reducerName) && (0, _persistentObjectReducer.isObjectUpToDate)(reducerName);
  });
};

exports.waitSync = waitSync;

var persistStore = function persistStore(store) {
  _store = store;
}; // Higher order reducer


exports.persistStore = persistStore;

var persistentReducer = function persistentReducer(db, reducerName, isArray) {
  return isArray ? (0, _persistentArrayReducer["default"])(storeGetter, db, reducerName) : (0, _persistentObjectReducer["default"])(storeGetter, db, reducerName);
};

exports.persistentReducer = persistentReducer;

var persistentDocumentReducer = function persistentDocumentReducer(db, reducerName) {
  return (0, _persistentObjectReducer["default"])(storeGetter, db, reducerName);
};

exports.persistentDocumentReducer = persistentDocumentReducer;

var persistentCollectionReducer = function persistentCollectionReducer(db, reducerName) {
  return (0, _persistentArrayReducer["default"])(storeGetter, db, reducerName);
};

exports.persistentCollectionReducer = persistentCollectionReducer;