"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.isObjectUpToDate = exports.INIT_OBJECT_REDUCER = exports.SET_OBJECT_REDUCER = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _ramdaUtils = require("./utils/ramdaUtils");

var _save = _interopRequireWildcard(require("./utils/save"));

var _waitAvailability = _interopRequireDefault(require("./utils/waitAvailability"));

var _log = _interopRequireDefault(require("./utils/log"));

var SET_OBJECT_REDUCER = '@@redux-pouchdb/SET_OBJECT_REDUCER';
exports.SET_OBJECT_REDUCER = SET_OBJECT_REDUCER;
var INIT_OBJECT_REDUCER = '@@redux-pouchdb/INIT_OBJECT_REDUCER';
exports.INIT_OBJECT_REDUCER = INIT_OBJECT_REDUCER;
var LOCAL_IDENTIFIER = Array(12).fill(0).map(function (_) {
  return String.fromCharCode(function (x) {
    return x > 25 ? x + 71 : x + 65;
  }(Math.floor(Math.random() * 52)));
}).join('');
var initialized = {};
var running = {};

var isRunning = function isRunning(reducerName) {
  return running[reducerName] !== undefined && running[reducerName] > 0;
};

var isInitialized = function isInitialized(reducerName) {
  return initialized[reducerName] !== false;
};

var isObjectUpToDate = function isObjectUpToDate(reducerName) {
  return (// log(
    //   'isObjectUpToDate',
    //   initialized[reducerName],
    //   isUpToDate(reducerName),
    //   !isRunning(reducerName)
    // ),
    isInitialized(reducerName) && (0, _save.isUpToDate)(reducerName) && !isRunning(reducerName)
  );
};

exports.isObjectUpToDate = isObjectUpToDate;

var setReducer = function setReducer(store, doc, reducerName) {
  var _id = doc._id,
      _rev = doc._rev,
      state = doc.state; // log('setReducer', doc)

  store.dispatch({
    type: SET_OBJECT_REDUCER,
    reducerName: reducerName,
    //_id,
    state: state,
    _rev: _rev
  });
}; // service


var initializePersistentObjectReducer = function initializePersistentObjectReducer(storeGetter, db, reducerName, saveReducer) {
  var store, res;
  return _regenerator["default"].async(function initializePersistentObjectReducer$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          _context.prev = 0;
          _context.next = 3;
          return _regenerator["default"].awrap((0, _waitAvailability["default"])(storeGetter));

        case 3:
          store = _context.sent;
          _context.next = 6;
          return _regenerator["default"].awrap(db.allDocs({
            include_docs: true
          }));

        case 6:
          res = _context.sent;
          _context.next = 9;
          return _regenerator["default"].awrap(Promise.all(res.rows.map(function (row) {
            return setReducer(store, row.doc, reducerName);
          })));

        case 9:
          // log('---dispatched docs------')
          db.changes({
            include_docs: true,
            live: true,
            since: 'now'
          }).on('change', function (change) {
            // if (change.doc.state && change.doc.madeBy !== LOCAL_IDENTIFIER) {
            //   setReducer(change.doc)
            // }
            var storeState = store.getState(); // log('doc change', JSON.stringify(change))

            if (change.doc.state) {
              // log(
              // !equalsOmittingDocProps(change.doc.state, storeState)
              // JSON.stringify(change.doc.state, null, 2),
              // JSON.stringify(storeState, null, 2)
              // )
              if (!(0, _ramdaUtils.equalsOmittingDocProps)(change.doc.state, storeState) && change.doc.madeBy !== LOCAL_IDENTIFIER) {
                setReducer(store, change.doc, reducerName);
              }
            } else {
              (0, _log["default"])(0);
              saveReducer(store.getState());
            }
          });
          initialized[reducerName] = true;
          store.dispatch({
            type: INIT_OBJECT_REDUCER
          }); // log('-----inited----')

          _context.next = 17;
          break;

        case 14:
          _context.prev = 14;
          _context.t0 = _context["catch"](0);
          console.error(_context.t0);

        case 17:
        case "end":
          return _context.stop();
      }
    }
  }, null, null, [[0, 14]]);
}; // Higher order reducer


var persistentObjectReducer = function persistentObjectReducer(storeGetter, db, reducerName) {
  return function (reducer) {
    var lastState;
    initialized[reducerName] = false;
    var saveReducer = (0, _save["default"])(db, reducerName, LOCAL_IDENTIFIER);
    initializePersistentObjectReducer(storeGetter, db, reducerName, saveReducer);
    return function (state, action) {
      // log('reducer', action.type, state)
      if (action.type === SET_OBJECT_REDUCER && action.reducerName === reducerName && action.state) {
        lastState = action.state;
        return reducer(action.state, action);
      }

      if (action.type === SET_OBJECT_REDUCER) {
        // Another reducer's state... ignore.
        return state;
      }

      var reducedState = reducer(state, action);

      var init = function init() {
        return _regenerator["default"].async(function init$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (!running[reducerName]) running[reducerName] = 0;
                running[reducerName] += 1;
                (0, _log["default"])('save?', isInitialized(reducerName), !(0, _ramdaUtils.equalsOmittingDocProps)(reducedState, lastState), reducedState);

                if ((0, _ramdaUtils.equalsOmittingDocProps)(reducedState, lastState)) {
                  _context2.next = 11;
                  break;
                }

                if (!isInitialized(reducerName)) {
                  _context2.next = 11;
                  break;
                }

                lastState = reducedState;
                (0, _log["default"])('init save');
                _context2.next = 9;
                return _regenerator["default"].awrap(saveReducer(reducedState));

              case 9:
                _context2.next = 11;
                break;

              case 11:
                running[reducerName] -= 1;

              case 12:
              case "end":
                return _context2.stop();
            }
          }
        });
      };

      init();
      return reducedState;
    };
  };
};

var _default = persistentObjectReducer;
exports["default"] = _default;