"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getDiff = exports.getInsertedItems = exports.getDeletedItems = exports.uniqOmittingDocProps = exports.equalsOmittingDocProps = exports.omitDocProps = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _ramda = require("ramda");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var omitDocProps = (0, _ramda.omit)(['_id', '_rev', '_deleted', 'madeBy']);
exports.omitDocProps = omitDocProps;

var equalsOmittingDocProps = function equalsOmittingDocProps(curr, old) {
  return (0, _ramda.equals)(omitDocProps(curr), omitDocProps(old));
};

exports.equalsOmittingDocProps = equalsOmittingDocProps;
var uniqOmittingDocProps = (0, _ramda.uniqWith)(equalsOmittingDocProps);
exports.uniqOmittingDocProps = uniqOmittingDocProps;

var getDeletedItems = function getDeletedItems(curr, old) {
  return (0, _ramda.differenceWith)(equalsOmittingDocProps, old, curr);
};

exports.getDeletedItems = getDeletedItems;
var getInsertedItems = (0, _ramda.differenceWith)(equalsOmittingDocProps);
exports.getInsertedItems = getInsertedItems;

var getDiff = function getDiff(curr, old) {
  return (0, _ramda.concat)(getInsertedItems(curr, old), getDeletedItems(curr, old).map(function (x) {
    return _objectSpread({}, x, {
      _deleted: true
    });
  }));
};

exports.getDiff = getDiff;