"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.isUpToDate = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _load = _interopRequireDefault(require("./load"));

var _log = _interopRequireDefault(require("./log"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var unpersistedQueue = {};
var isUpdating = {};

var isUpToDate = function isUpToDate(reducerName) {
  return !isUpdating[reducerName] && (!unpersistedQueue[reducerName] || !unpersistedQueue[reducerName].length);
};

exports.isUpToDate = isUpToDate;

var _default = function _default(db, reducerName, madeBy) {
  var loadReducer = (0, _load["default"])(db);

  var saveReducer = function saveReducer(reducerState) {
    var doc, newDoc, next;
    return _regenerator["default"].async(function saveReducer$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (!isUpdating[reducerName]) {
              _context.next = 3;
              break;
            }

            //enqueue promise
            unpersistedQueue[reducerName] = (unpersistedQueue[reducerName] || []).concat(reducerState);
            return _context.abrupt("return");

          case 3:
            isUpdating[reducerName] = true;
            _context.prev = 4;
            _context.next = 7;
            return _regenerator["default"].awrap(loadReducer(reducerName));

          case 7:
            doc = _context.sent;
            newDoc = _objectSpread({}, doc, {
              madeBy: madeBy,
              state: reducerState
            }); // const newDoc = {
            //   ...doc
            // }
            // if (Array.isArray(reducerState)) {
            //   newDoc.state = [...(doc.state || []), ...reducerState]
            // } else {
            //   newDoc.state = {
            //     ...doc.state,
            //     ...reducerState
            //   }
            // }

            (0, _log["default"])('put', newDoc, isUpdating[reducerName], unpersistedQueue[reducerName], (0, _typeof2["default"])(unpersistedQueue[reducerName]) // Object.keys(unpersistedQueue[reducerName]),
            // unpersistedQueue[reducerName].lenght
            );
            _context.next = 12;
            return _regenerator["default"].awrap(db.put(newDoc));

          case 12:
            isUpdating[reducerName] = false;

            if (!unpersistedQueue[reducerName] //&&
            // unpersistedQueue[reducerName].length
            ) {
              _context.next = 19;
              break;
            }

            next = unpersistedQueue[reducerName].shift();
            (0, _log["default"])('next', next);
            _context.next = 18;
            return _regenerator["default"].awrap(saveReducer(next));

          case 18:
            return _context.abrupt("return", _context.sent);

          case 19:
            _context.next = 24;
            break;

          case 21:
            _context.prev = 21;
            _context.t0 = _context["catch"](4);
            console.error(_context.t0);

          case 24:
          case "end":
            return _context.stop();
        }
      }
    }, null, null, [[4, 21]]);
  };

  return saveReducer;
};

exports["default"] = _default;