"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.isUpToDate = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _loadArray = _interopRequireDefault(require("./loadArray"));

var _ramdaUtils = require("./ramdaUtils");

var _log = _interopRequireDefault(require("./log"));

var unpersistedQueue = {};
var isUpdating = {};
var waitingChanges = {};

var isUpToDate = function isUpToDate(reducerName) {
  // log('isUpToDate', !isUpdating[reducerName], unpersistedQueue[reducerName])
  // log(isUpdating, unpersistedQueue, waitingChanges, reducerName)
  return (isUpdating[reducerName] === undefined || !isUpdating[reducerName]) && (unpersistedQueue[reducerName] === undefined || !unpersistedQueue[reducerName]) && !waitingChanges[reducerName];
};

exports.isUpToDate = isUpToDate;

var _default = function _default(db, reducerName) {
  var loadArrayReducer = (0, _loadArray["default"])(db);

  var saveReducer = function saveReducer(reducerState) {
    var docs, diff, _docs, bulk, next;

    return _regenerator["default"].async(function saveReducer$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (!isUpdating[reducerName]) {
              _context.next = 7;
              break;
            }

            _context.next = 3;
            return _regenerator["default"].awrap(loadArrayReducer(reducerName));

          case 3:
            docs = _context.sent;
            diff = (0, _ramdaUtils.getDiff)(reducerState, docs);

            if (diff.length) {
              //enqueue promise
              unpersistedQueue[reducerName] = (0, _ramdaUtils.uniqOmittingDocProps)(diff.concat(unpersistedQueue[reducerName])); // log(
              //   'enqueue',
              //   unpersistedQueue[reducerName].length,
              //   unpersistedQueue[reducerName]
              // )
            }

            return _context.abrupt("return");

          case 7:
            isUpdating[reducerName] = true;
            _context.prev = 8;

            if (Array.isArray(reducerState)) {
              _context.next = 11;
              break;
            }

            throw new Error("State of ".concat(reducerName, " must be an array"));

          case 11:
            _context.next = 13;
            return _regenerator["default"].awrap(loadArrayReducer(reducerName));

          case 13:
            _docs = _context.sent;
            // log('load to save docs', docs.length)
            bulk = (0, _ramdaUtils.getDiff)(reducerState, _docs); // log(bulk.length, 'reducerState', reducerState, 'docs', docs)

            if (!bulk.length) {
              _context.next = 21;
              break;
            }

            if (!waitingChanges[reducerName]) waitingChanges[reducerName] = 0;
            waitingChanges[reducerName] += 1; // log('bulk', bulk, 'waitingChanges', waitingChanges)

            _context.next = 20;
            return _regenerator["default"].awrap(db.bulkDocs(bulk));

          case 20:
            waitingChanges[reducerName] -= 1;

          case 21:
            // log('IS UP TO DATE', reducerName, isUpToDate(reducerName))
            isUpdating[reducerName] = false;

            if (!unpersistedQueue[reducerName]) {
              _context.next = 28;
              break;
            }

            next = unpersistedQueue[reducerName];
            unpersistedQueue[reducerName] = null;
            _context.next = 27;
            return _regenerator["default"].awrap(saveReducer(next));

          case 27:
            return _context.abrupt("return", _context.sent);

          case 28:
            _context.next = 33;
            break;

          case 30:
            _context.prev = 30;
            _context.t0 = _context["catch"](8);
            console.error(_context.t0);

          case 33:
          case "end":
            return _context.stop();
        }
      }
    }, null, null, [[8, 30]]);
  };

  return saveReducer;
};

exports["default"] = _default;